Crypto++ 8.2 Free C++ class library of cryptographic schemes

Public Types | Public Member Functions | Static Public Attributes | List of all members
IteratedHash< T_HashWordType, T_Endianness, T_BlockSize, T_Base > Class Template Reference

Iterated hash base class. More...

Inheritance diagram for IteratedHash< T_HashWordType, T_Endianness, T_BlockSize, T_Base >:

## Public Types
typedef T_Endianness | ByteOrderClass
typedef T_HashWordType | HashWordType
Public Types inherited from IteratedHashBase< T_HashWordType, T_Base >
typedef T_HashWordType | HashWordType

## Public Member Functions
unsigned int | BlockSize () const
| Provides the block size of the hash. More...
ByteOrder | GetByteOrder () const
| Provides the byte order of the hash. More...
void | CorrectEndianess (HashWordType *out, const HashWordType *in, size_t byteCount)
| Adjusts the byte ordering of the hash. More...
Public Member Functions inherited from IteratedHashBase< T_HashWordType, T_Base >
| IteratedHashBase ()
| Construct an IteratedHashBase.
unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this cipher. More...
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
void | Update (const byte *input, size_t length)
| Updates a hash with additional input. More...
byte * | CreateUpdateSpace (size_t &size)
| Requests space which can be written into by the caller. More...
void | Restart ()
| Restart the hash. More...
void | TruncatedFinal (byte *digest, size_t digestSize)
| Computes the hash of the current message. More...
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...

## Static Public Attributes
static const int | BLOCKSIZE = T_BlockSize

## Detailed Description

### template<class T_HashWordType, class T_Endianness, unsigned int T_BlockSize, class T_Base = HashTransformation>
class IteratedHash< T_HashWordType, T_Endianness, T_BlockSize, T_Base >

Iterated hash base class.

Template Parameters

  T_HashWordType | Hash word type
  T_Endianness | Endianness type of hash
  T_BlockSize | Block size of the hash
  T_Base | HashTransformation derived class

IteratedHash provides a default implementation for block-based iterated hashes

See also
  HashTransformation, MessageAuthenticationCode

Definition at line 126 of file iterhash.h.

## Member Function Documentation

## ◆ BlockSize()

template<class T_HashWordType, class T_Endianness, unsigned int T_BlockSize, class T_Base = HashTransformation>

unsigned int IteratedHash< T_HashWordType, T_Endianness, T_BlockSize, T_Base >::BlockSize | ( |  | ) | const
| inline

Provides the block size of the hash.

Returns
  the block size of the hash, in bytes

BlockSize() returns `T_BlockSize`.

Definition at line 141 of file iterhash.h.

## ◆ GetByteOrder()

template<class T_HashWordType, class T_Endianness, unsigned int T_BlockSize, class T_Base = HashTransformation>

ByteOrder IteratedHash< T_HashWordType, T_Endianness, T_BlockSize, T_Base >::GetByteOrder | ( |  | ) | const
| inline virtual

Provides the byte order of the hash.

Returns
  the byte order of the hash as an enumeration

GetByteOrder() returns `T_Endianness::ToEnum()`.

See also
  ByteOrder()

Implements IteratedHashBase< T_HashWordType, T_Base >.

Definition at line 147 of file iterhash.h.

## ◆ CorrectEndianess()

template<class T_HashWordType, class T_Endianness, unsigned int T_BlockSize, class T_Base = HashTransformation>

void IteratedHash< T_HashWordType, T_Endianness, T_BlockSize, T_Base >::CorrectEndianess | ( | HashWordType * | out,
|  | const HashWordType * | in,
|  | size_t | byteCount
| ) |  |
| inline

Adjusts the byte ordering of the hash.

Parameters

  out | the output buffer
  in | the input buffer
  byteCount | the size of the buffers, in bytes

CorrectEndianess() calls ConditionalByteReverse() using `T_Endianness`.

Definition at line 154 of file iterhash.h.

The documentation for this class was generated from the following file:

- iterhash.h